<!DOCTYPE html>
<html>
<title id = "voxl-portal-title">ModalAI VOXL Portal</title>
<meta name="viewport" content="width=device-width, initial-scale=1">
<link rel="stylesheet" href="./css/w3.css">
<link rel="icon" href="./images/portal.png">

<header>
    <script src="./js/3rd_party/jquery-3.6.0.js"></script>
    <script>
        $(function(){
          $("#header").load("header.html", function(){
            mode_btn.addEventListener("click", () => {
                if (mode_btn.classList.contains("w3-black")) {
                    var x = document.getElementById("button_text");
                    x.textContent = "Dark";
                    mode_btn.classList.replace("w3-black", "w3-white");
                    document.body.style.background = "black";
                    var center_title = document.getElementById("all_text");
                    center_title.style.color = "white";
                    var version_text = document.getElementById("center_id");
                    version_text.style.color = "white";
                    localStorage.setItem("dark_mode","true");
                }
                else {
                    mode_btn.classList.replace("w3-white", "w3-black");
                    var x = document.getElementById("button_text");
                    x.textContent = "Light";
                    document.body.style.background = "white";
                    var center_title = document.getElementById("all_text");
                    center_title.style.color = "black";
                    var version_text = document.getElementById("center_id");
                    version_text.style.color = "black";
                    localStorage.setItem("dark_mode","false");
                }
            })
            var dark_mode_status = localStorage.getItem("dark_mode");
            if (dark_mode_status == "true"){
                // we were in Dark on the previous page, so mimic thats
                mode_btn.click();
            }
          });
        });
    </script>
    <div id="header" class="w3-container w3-green" style="height:50px; align-items: center; display:flex;">
        <h1>VOXL Web Portal</h1>
    </div>
</header>
<style>
    pre {
        white-space: pre-wrap;
    }
    .container {
        display: flex;
        justify-content: center;
        align-items: center;
    }
</style>
<body>
    <center id = "all_text">
        <h1>VOXL Version</h1>
    </center>
    <div id = center_id class = "container">
        <pre id = "center_display">
            <!--Will be filled in when clicking the version button under the debug window-->
        </pre>
    </div>
</body>

<script src="./js/get_url.js"></script>
<script>

    var url_base = get_url_base();
    var url_port = get_url_port();

    function renderAnsiCodes(text) {
    // Define the mapping of ANSI codes to HTML tags
        var ansiMap = {
            '\u001b[1m': '<span style="font-weight: bold;">',
            '\u001b[31m': '<span style="color: red;">',
            '\u001b[32m': '<span style="color: green;">',
            '\u001b[33m': '<span style="color: yellow;">',
            '\u001b[34m': '<span style="color: blue;">',
            '\u001b[35m': '<span style="color: magenta;">',
            '\u001b[36m': '<span style="color: cyan;">',
            '\u001b[37m': '<span style="color: white;">',
            '\u001b[39m': '<span style="color: inherit;">',
            '\u001b[0m': '</span>'
        };

        // Regular expression to match ANSI escape codes
        var ansiRegex = /\u001b\[(?:\d{1,2}(?:;\d{1,2})*)?[m|K]/g;

        // Replace ANSI codes with equivalent HTML tags
        var replacedText = text.replace(ansiRegex, function (match) {
            if (ansiMap.hasOwnProperty(match)) {
                return ansiMap[match];
            } else {
                return '';
            }
        });

        return replacedText;
    }

    var url = window.location.href;
    var url_partial = url.split("/");
    var version_ws = new WebSocket("ws://" + url_base + ":" + url_port + "/version_info");
    version_ws.binaryType = "arraybuffer";
    version_ws.onopen = function() {
        console.log("[INFO] Version websocket open");
    };
    version_ws.onmessage = function(evt) {
        var msg = evt.data
        var formatted_msg = renderAnsiCodes(msg);
        var display_data = document.getElementById("center_display");
        display_data.innerHTML = formatted_msg;
    }
    $(window).on('beforeunload', function(){
        version_ws.close();
        console.log("Version WebSocket is now closed");
    });

</script>
